package searche;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

class BinaryTextInputStream
{
	protected InputStream mIn;

	public BinaryTextInputStream(InputStream aIn)
	{
		mIn = aIn;
	}

	/**
	 * Reads a text line from the stream.
	 * @return the line read or null if the end of stream is reached.
	 * Considers the line finishes with either "\n" or "\r\n".
	 * @throw IOException in case of I/O problem.
	 */
	public String readLine()
	throws IOException
	{
		StringBuffer line = new StringBuffer();
		while (true) {
			int nextByte = mIn.read();
			if (nextByte == -1) // EOF
				if (line.length()==0)
					return null;
				else
					break;
			char ch = (char) nextByte;
			if (ch == '\n')
				break;
			line.append(ch);
		}
		if ( (line.length()>0) && (line.charAt(line.length()-1)=='\r'))
			line.setLength(line.length()-1);
		return new String(line);
	}

	/**
	 * Delegates to InputStream.read(byte[] b).
	 */
	public int read()
	throws IOException
	{
		return mIn.read();
	}

}

public class Download extends HttpServlet {


	public void doGet(HttpServletRequest request,HttpServletResponse response)
	{
			OutputStream out;
			String filename;
			String content;
			filename=request.getParameter("filename");


			try{
				File f=new File(filename);
				String contenttype;
				long filesize=f.length();
				byte b;
				int i=0;
				FileInputStream fstream=new FileInputStream(f);
				contenttype="application/octet-stream";
				if(filename.endsWith(".au")) contenttype="audio/basic";
				if(filename.endsWith(".avi")) contenttype="video/x-msvideo";
				if(filename.endsWith(".bmp")) contenttype="image/bmp";
				if(filename.endsWith(".css")) contenttype="text/css";
				if(filename.endsWith(".doc")) contenttype="application/msword";
				if(filename.endsWith(".dll")) contenttype="application/x-msdownload";
				if(filename.endsWith(".exe")) contenttype="application/x-msdownload";
				if(filename.endsWith(".gif")) contenttype="image/gif";
				if(filename.endsWith(".jpg")) contenttype="image/jpeg";
				if(filename.endsWith(".jpeg")) contenttype="image/jpeg";
				if(filename.endsWith(".jpg")) contenttype="image/jpeg";
				if(filename.endsWith(".js")) contenttype="application/x-javascript";
				if(filename.endsWith(".mid")) contenttype="audio/midi";
				if(filename.endsWith(".midi")) contenttype="audio/midi";
				if(filename.endsWith(".mov")) contenttype="video/quicktime";
				if(filename.endsWith(".htm")) contenttype="text/html";
				if(filename.endsWith(".html")) contenttype="text/html";
				if(filename.endsWith(".zip")) contenttype="application/x-zip-compressed";




				response.setContentType(contenttype);
				response.setContentLength((int)filesize);
				response.setHeader("Content-Disposition", "attachment; filename=\""
				+ f.getName() + "\"");

				out=response.getOutputStream();
				while(i!=filesize)				{
					b=(byte)fstream.read();
					out.write(b);
					i++;
				}


			}catch(IOException e){}





	}
}